Status: Closed   

Priority: Normal   
Target version:    

ruby -v:  Backport: 2.7: REQUIRED, 3.0: REQUIRED, 3.1:

DONE

Description

__ENCODING__ should respect the encoding of the given source code.

$ ruby -Ke -e 'p __ENCODING__'

#<Encoding:EUC-JP>

 
p eval("__ENCODING__".encode("euc-jp")) #=> #<Encoding:EUC-JP>

 But it is ignored when SCRIPT_LINES__ is set.

$ cat script_lines.rb

SCRIPT_LINES__ = {}

$ ruby -r./script_lines.rb -Ke -e 'p __ENCODING__'

#<Encoding:UTF-8>

 Also similar when keep_script_lines is true.

pp RubyVM::AbstractSyntaxTree.parse("__ENCODING__".encode("euc-jp"), keep_script_lines: true)

#=> (SCOPE@1:0-1:12 tbl: [] args: nil body: (LIT@1:0-1:12 #<Encoding:UTF-8>))

Associated revisions

Revision cd5cafa4a380e2459862b6e99ff0c381362ef1be - 06/16/2022 04:48 PM - nobu (Nobuyoshi Nakada)

Respect the encoding of the source [Bug #18827]

Do not override the input string encoding at the time of preparation,

the source encoding is not determined from the input yet.

Revision cd5cafa4a380e2459862b6e99ff0c381362ef1be - 06/16/2022 04:48 PM - nobu (Nobuyoshi Nakada)

Respect the encoding of the source [Bug #18827]

Do not override the input string encoding at the time of preparation,

the source encoding is not determined from the input yet.

Revision cd5cafa4 - 06/16/2022 04:48 PM - nobu (Nobuyoshi Nakada)

Respect the encoding of the source [Bug #18827]

Do not override the input string encoding at the time of preparation,

the source encoding is not determined from the input yet.

Revision 8c99882dad0b6fedbd656889829a3780366bd8b6 - 03/25/2023 01:33 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) cd5cafa4a380e2459862b6e99ff0c381362ef1be: [Backport #18827]

    Respect the encoding of the source [Bug #18827]

    Do not override the input string encoding at the time of preparation,

    the source encoding is not determined from the input yet.

    ---

     parse.y                  | 26 ++++++++++++++++----------

     test/ruby/test_ast.rb    | 13 +++++++++++++

     test/ruby/test_syntax.rb |  9 +++++++++
     3 files changed, 38 insertions(+), 10 deletions(-)

Revision 8c99882dad0b6fedbd656889829a3780366bd8b6 - 03/25/2023 01:33 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) cd5cafa4a380e2459862b6e99ff0c381362ef1be: [Backport #18827]

    Respect the encoding of the source [Bug #18827]

    Do not override the input string encoding at the time of preparation,

    the source encoding is not determined from the input yet.

    ---

     parse.y                  | 26 ++++++++++++++++----------

     test/ruby/test_ast.rb    | 13 +++++++++++++

     test/ruby/test_syntax.rb |  9 +++++++++

     3 files changed, 38 insertions(+), 10 deletions(-)

Revision 8c99882d - 03/25/2023 01:33 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) cd5cafa4a380e2459862b6e99ff0c381362ef1be: [Backport #18827]

    Respect the encoding of the source [Bug #18827]

    Do not override the input string encoding at the time of preparation,

    the source encoding is not determined from the input yet.

    ---

     parse.y                  | 26 ++++++++++++++++----------

     test/ruby/test_ast.rb    | 13 +++++++++++++

     test/ruby/test_syntax.rb |  9 +++++++++

     3 files changed, 38 insertions(+), 10 deletions(-)

History

#1 - 06/14/2022 03:43 AM - nobu (Nobuyoshi Nakada)

https://github.com/ruby/ruby/pull/6015

#2 - 06/16/2022 04:49 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|cd5cafa4a380e2459862b6e99ff0c381362ef1be.

Respect the encoding of the source [Bug #18827]

Do not override the input string encoding at the time of preparation,

the source encoding is not determined from the input yet.

#3 - 03/25/2023 02:27 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.7: REQUIRED, 3.0: REQUIRED, 3.1: REQUIRED to 2.7: REQUIRED, 3.0: REQUIRED, 3.1: DONE

ruby_3_1 8c99882dad0b6fedbd656889829a3780366bd8b6 merged revision(s) cd5cafa4a380e2459862b6e99ff0c381362ef1be.
